#include "libcell.h"

void get_port_data (_comm_header *comm, _path *path, _port *port, int debug)
{
int x;
_data_buffer *buff;
_encaps_header *head;
_data_buffer *sendbuff;
_data_buffer *msgbuff;
_ioi_data *ioi1;

dprint(DEBUG_TRACE, "get_port_data.c entered.\n");

if (path == NULL)
	{
	printf ("path structure not allocated - get_port_data.c\n");
	return;
	}
if (port == NULL)
	{
	printf ("port structure not allocated - get_port_data.c\n");
	return;
	}

buff = malloc(sizeof(_data_buffer));
if (buff == NULL)
	{
	printf ("Could not allocate memory for data buffer - get_port_data.c\n");
	return;
	}
msgbuff = malloc(sizeof(_data_buffer));
if (msgbuff == NULL)
	{
	printf ("Could not allocate memory for msgdata buffer - get_port_data.c\n");
	return;
	}
head = malloc(sizeof(_encaps_header));
if (head == NULL)
	{
	printf ("Could not allocate memory for Encaps Header - get_port_data.c\n");
	free (buff);
	return;
	}
sendbuff = malloc(DATA_Buffer_Length);
if (sendbuff == NULL)
	{
	printf ("Could not allocate memory for send buffer - get_port_data.c\n");
	free(buff);
	free(head);
	return;
	}

ioi1 = malloc(sizeof(_ioi_data));
if (ioi1 == NULL)
	{
	printf ("Could not allocate memory for ioi buffer - get_port_data.c\n");
	free (buff);
	free (head);
	free (sendbuff);
	return;
	}	

memset(buff,0,sizeof(_data_buffer));
memset(msgbuff,0,sizeof(_data_buffer));
memset(head,0,sizeof(_encaps_header));
memset(sendbuff,0,sizeof(_data_buffer));
memset(ioi1,0,sizeof(_ioi_data));

buff->len = 0;

msgbuff->data[msgbuff->len++] = GET_ATTRIBUTE_SINGLE;

ioi1->class = PORT_OBJECT;
ioi1->instance = BASE_INSTANCE;
ioi1->member = -1;
ioi1->point = -1;
ioi1->attribute = ENTRY_PORT;
ioi1->tagname = NULL;

ioi(msgbuff, ioi1, NULL, debug);
makepath(path, msgbuff, debug);
if (debug != DEBUG_NIL)
	{
	dprint (DEBUG_BUILD,"Msgbuff = ");
	for (x=0;x<msgbuff->len;x++)
		dprint (DEBUG_BUILD,"%02X ",msgbuff->data[x]);
	dprint (DEBUG_BUILD,"\n");
	}



sendRRdata (10, comm, head, buff, debug);
cpf (CPH_Null, NULL, CPH_Unconnected_message, msgbuff, buff, debug);
head->len = buff->len;
memcpy (sendbuff->data, head, ENCAPS_Header_Length);
sendbuff->overall_len = ENCAPS_Header_Length;
if (debug != DEBUG_NIL)
	{
	dprint (DEBUG_BUILD,"Loading sendbuffer with command data.\n");
	for (x=0;x<buff->len;x++)
		dprint (DEBUG_BUILD,"%02X ",buff->data[x]);
	dprint (DEBUG_BUILD,"\n");
	}
memcpy (sendbuff->data + sendbuff->overall_len, buff->data, buff->len);
sendbuff->overall_len += buff->len;
senddata (sendbuff, comm, debug);
readdata (buff, comm, debug);
memset (head,0, ENCAPS_Header_Length);
memcpy (head,buff->data,ENCAPS_Header_Length);
if (head->status != 0)
	{
	dprint (DEBUG_VALUES,"Get port Data command returned an error.\n");
	return;
	}
//buff = buff + ENCAPS_Header_Length;
memset (port,0, sizeof(_port));
memcpy (port, buff->data+40, sizeof(_port));

if (debug != DEBUG_NIL)
	{
	dprint (DEBUG_VALUES,"Port slot reported as %d.\n",port->slot);
	dprint (DEBUG_VALUES,"Got good reply to Get Port Data Command\n");	
	for (x=40;x<sizeof(_port)+39;x++)
		dprint (DEBUG_VALUES,"%02X ",buff->data[x]);
	dprint (DEBUG_VALUES,"\n");
	}


free(buff);
free(head);
free(sendbuff);
free(msgbuff);
dprint (DEBUG_TRACE, "get_port_data.c exiting.\n");
return;
}
